unit unitrectmag;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TformRectMag = class(TForm)
    timerRefresh: TTimer;
    procedure timerRefreshTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    initialized: Boolean;
  public
    { Public declarations }
    procedure doCopy(rectSource: TRect);
    procedure doClear();
  end;

var
  formRectMag: TformRectMag;

implementation

{$R *.dfm}

const
  SETTING_INTERVAL = 50;
  SETTING_SOURCETOP = 90;
  SETTING_SOURCELEFT = 740;
  SETTING_SOURCEWIDTH = 278;
  SETTING_SOURCEHEIGHT = 620;
  SETTING_DESTMONITOR = -1;
  SETTING_DESTTOP = 0;
  SETTING_DESTLEFT = 1224;
  SETTING_DESTWIDTH = 624;
  SETTING_DESTHEIGHT = 768;

function EnumChildProc(ahwnd: HWND; alParam: LPARAM): Boolean; stdcall;
var
  text: array[0..255] of Char;
  textTrimmed: string;
  r: TRect;
begin
  GetClassName(ahwnd, text, Length(text) - 1);
  textTrimmed := Trim(text);
  if textTrimmed = 'CTGrid' then
  begin
    GetWindowRect(GetParent(GetParent(GetParent(ahwnd))), r);
    formRectMag.doCopy(r);
    Result := False;
  end
  else
    Result := True;
end;

procedure TformRectMag.doCopy(rectSource: TRect);
var
  wndSource: THandle;
  hdcSource: THandle;
  canvasSource: TCanvas;
begin
  if not(Visible) then
    Show();
  wndSource := GetDesktopWindow();
  hdcSource := GetWindowDC(wndSource);
  try
    canvasSource := TCanvas.Create();
    try
      canvasSource.Handle := hdcSource;
      Canvas.CopyRect(
        Bounds(0, 0, SETTING_DESTWIDTH, SETTING_DESTHEIGHT),
        canvasSource,
        rectSource
      );
    finally
      FreeAndNil(canvasSource);
    end;
  finally
    ReleaseDC(wndSource, hdcSource);
  end;
end;

procedure TformRectMag.doClear();
begin
  Canvas.Brush.Color := Color;
  Canvas.FillRect(Bounds(0, 0, SETTING_DESTWIDTH, SETTING_DESTHEIGHT));
  if Visible then
    Hide();
end;

procedure TformRectMag.timerRefreshTimer(Sender: TObject);
var
  wnd: THandle;
begin
  wnd := FindWindow('TfrmPhMain', nil);
  if ((wnd <> INVALID_HANDLE_VALUE) and EnumChildWindows(wnd, @EnumChildProc, 0)) then
    doClear();
end;

procedure TformRectMag.FormCreate(Sender: TObject);
begin
  initialized := False;
  DoubleBuffered := True;
  timerRefresh.Interval := SETTING_INTERVAL;
end;

procedure TformRectMag.FormActivate(Sender: TObject);
begin
  if not(initialized) then
  begin
    if (SETTING_DESTMONITOR > -1) and (Screen.MonitorCount > SETTING_DESTMONITOR) then
    begin
      BoundsRect := Screen.Monitors[SETTING_DESTMONITOR].BoundsRect;
    end
    else
    begin
      SetBounds(SETTING_DESTLEFT, SETTING_DESTTOP, SETTING_DESTWIDTH, SETTING_DESTHEIGHT);
    end;
    timerRefresh.Enabled := True;
  end;
end;

end.
